import nodeBuilder from './nodeBuilder';
import addTabs from './addTabs';

export default class {
  constructor({ params, body }, level) {
    this.params = params;
    this.body = body;
    this.level = level;
  }

  explain() {
    const params = this.params.map(p => p.name).join(', ');
    const body = nodeBuilder(this.body, this.level + 1);
    const explanation = `${params} - parameters of function\nBody of function:\n  ${body.explain()}`;
    return `Declaration of function:\n${explanation.split('\n').map(str => addTabs(str, this.level)).join('\n')}`;
  }
}
