import nodeBuilder from './nodeBuilder';

export default class {
  constructor(body) {
    this.callee = body.callee;
    this.arguments = body.arguments;
  }

  explain() {
    const funcName = `${this.callee.name} - name of function`;
    const args = this.arguments.map(arg => nodeBuilder(arg, 0).toString()).join(', ');
    return ['Calling a function:', funcName, `${args} - arguments of function`].join('\n');
  }
}
