import nodeBuilder from './nodeBuilder';
import addTabs from './addTabs';

export default class {
  constructor({ test, consequent, alternate }, level) {
    this.test = test;
    this.consequent = consequent;
    this.alternate = alternate;
    this.level = level;
  }

  explain() {
    const ifExplain = 'if - The if statement executes a statement if a specified condition is truthy. If the condition is falsy, another statement can be executed';
    const test = `${nodeBuilder(this.test, this.level)} - condition of if statemant, which should always return true or false`;
    const consequent = nodeBuilder(this.consequent, this.level + 1).explain().map(str => addTabs(str, this.level + 1));
    const consequentExplain = `Statement that is executed if condition is truthy:\n${consequent}`;
    return [ifExplain, test, consequentExplain].join('\n');
  }
}