import nodeBuilder from './nodeBuilder';
import addTabs from './addTabs';

export default class {
  constructor({ declarations, kind }, level) {
    this.declarations = declarations;
    this.kind = kind;
    this.level = level;
  }

  explain() {
    const declarationExplains = this.declarations
      .map(node => nodeBuilder(node, this.level + 1))
      .map(node => node.explain());

    return [this.explainKind(), ...declarationExplains]
      .map(el => addTabs(el, this.level))
      .join('\n');
  }

  explainKind() {
    const kindExplains = {
      const: 'a declaration of local constant, which value you cannot change (immutable)',
      let: 'a declaration of local variable, which value you can change (mutable)',
    };

    return `${this.kind} - ${kindExplains[this.kind]}`;
  }
}
